function initArray(m)
local array = {}
for i = 1, m do
array[i]=0
end
return array
end
level=initArray(32)
exp=initArray(32)

function string.split(text,b)
local cmd = {}
if b then
b = b
else
b = "%s"
end
b = "[^"..b.."]+"
for o in string.gmatch(text,b) do
table.insert(cmd,o)
end
return cmd
end

function totable(t,match)
     local cmd = {}
     if not match then match = "[^%s]+" end
     for word in string.gmatch(t, match) do
          table.insert(cmd, word)
     end
     return cmd
end 

addhook("ms100","save_hud")
function save_hud()
     for id = 1,32 do
          if (player(id,"exists")) then
               parse('hudtxt2 '..id..' 48 "000100255Level: '..level[id]..' " 13 117')
               parse('hudtxt2 '..id..' 49 "000100255Exp: '..exp[id]..'/8 " 13 129')
          end
     end
end

addhook("kill","save_kill")
function save_kill(id)
	exp[id]=exp[id]+1
	if exp[id] == 8 then
		exp[id]=0
		level[id]=level[id]+1
		msg2(id,"000255000Level up!@C")
		parse("sv_sound2 "..id.." levelup.wav")
		msg("255075000"..player(id,"name").." reached "..level[id].." level!")
	end
	if exp[id] < 8 then
		parse("sv_sound2 "..id.." coin.wav")
	end
end

addhook("leave","save_leave") -- When you leave it saves
function save_leave(id)
     if (player(id,"usgn")>0) then
          io.output(io.open("sys/lua/saves/"..player(id,"usgn")..".txt","w+"))
          io.write(exp[id].." "..level[id])
          io.close()
     end
end

addhook("die","save_die") -- When you die it saves
function save_die(id)
     if (player(id,"usgn")>0) then
          io.output(io.open("sys/lua/saves/"..player(id,"usgn")..".txt","w+"))
          io.write(exp[id].." "..level[id])
          io.close()
     end
end

addhook("join","save_join") -- When join load
function save_join(id)
	if (player(id,"usgn")>0) then
		local filename = "sys/lua/saves/%s.txt"
		local file = io.open(filename:format(player(id,"usgn"), "r"))
		local line
		if not file then
			line = {0, 1}
			msg2(id,"255000000Failed to save!@C")
		else
			line = file:read("*a"):split()
		end
		exp[id] = tonumber(line[1]) or 0 -- If line[1] is not a number, level[id] becomes 1
		level[id] = tonumber(line[2]) or 1 -- Same as above reasoning (prevents errors)
	else
		msg2(id,"255000000No USGN found!@C")
		level[id]=1
	end
end

addhook("parse","save_parse")
function save_parse(cmd)
	_msg=totable(cmd)
	_t1=tostring(_msg[1])
	if (_t1=="set_lvl") then
		_t2=tonumber(_msg[2])
		_t3=tonumber(_msg[3])
		level[_t2]=_t3
		msg2(_t2,"000255000Admin set your level to ".._t3.."!@C")
		parse("sv_sound2 ".._t2.." levelup.wav")
		msg("255075000Admin set "..player(_t2,"name").." level to ".._t3.."!")
	end
	if (_t1=="give_lvl") then
		_t2=tonumber(_msg[2])
		_t3=tonumber(_msg[3])
		level[_t2]=level[_t2]+_t3
		msg2(_t2,"000255000Admin give you ".._t3.." levels!@C")
		parse("sv_sound2 ".._t2.." levelup.wav")
		msg("255075000Admin give "..player(_t2,"name").." ".._t3.." levels!")
	end
end

addhook("say","save_say")
function save_say(id,txt)
	if (txt=="!reset") then
		menu(id,"Reset your level?,Yes,No")
		parse("sv_sound2 "..id.." menu.wav")
		return 1
	end
end

addhook("say","save_sayy")
function save_sayy(id,txt)
	if txt == "!lvl_help" then
		msg2(id,"000255000Server commands:")
		msg2(id,"100255100!lvl_help - see Level and Exp mode commands")
		msg2(id,"100255100!reset - reset your level to 1")
		msg2(id,"100255100!info - See player level and exp")
		return 1
	end
end

addhook("say","save_sayyy")
function save_sayyy(id,txt)
	_msg=totable(txt)
	_t1=tostring(_msg[1])
	if _t1 == "!info" then
		_t2=tonumber(_msg[2])
		msg2(id,"000100255"..player(_t2,"name").." has "..level[_t2].." level and "..exp[_t2].." exp.")
		return 1
	end
end

addhook("menu","save_menu")
function save_menu(id,title,sel)
	if title == "Reset your level?" then
		if sel == 1 then
			msg("255000000"..player(id,"name").." Has reset level!")
			level[id]=1
			exp[id]=0
		elseif sel == 2 then
			level[id]=level[id]
			exp[id]=exp[id]
		end
	end
end

addhook("minute","save_minute")
function save_minute()
	msg("000255000Level and Exp (v1.7) mode by RyceR")
	msg("000255000Say !lvl_help to see Level and Exp mode commands")
	msg("000255000Have Fun!")
end